<script type="text/javascript">
    RED.nodes.registerType('prometheus-query', {
        category: 'prometheus',
        color: '#F3B567',
        defaults: {
            name: { 
                value: "" 
            },
            server: {
                required: true,
                type: "prometheus-server"
            },
            query: {
                value: null,
                required: false,
            },
            time: { 
                value: null,
                required: false
            },
            timeout: {
                value: 1000,
                required: false,
                validate: RED.validators.number()
            }
        },
        inputs: 1,
        outputs: 1,
        icon: "prometheus.png",
        paletteLabel: "query",
        label: function() {
            return this.name || "query";
        },
        oneditprepare: function () {
            this.editor = RED.editor.createEditor({
                id: 'node-input-query-editor',
                mode: 'ace/mode/text',
                value: this.query
            });
        },
        oneditsave: function() {
            this.query = this.editor.getValue();
            this.editor.destroy();
            delete this.editor;
        },
        oneditcancel: function() {
            this.editor.destroy();
            delete this.editor;
        }
    });
</script>

<script type="text/html" data-template-name="prometheus-query">
    <div class="form-row">
        <label for="node-input-server"><i class="fa fa-globe"></i> Server</label>
        <input type="text" id="node-input-server" placeholder="Prometheus Server">
    </div>
    <div class="form-row">
        <label for="node-input-query"><i class="fa fa-search"></i> PromQL</label>
        <div style="height: 250px; min-height:150px;" class="node-text-editor" id="node-input-query-editor"></div>
    </div>
    <div class="form-row">
        <label for="node-input-time"><i class="fa fa-clock-o"></i> Time</label>
        <input type="text" id="node-input-time" placeholder="Time">
    </div>
    <div class="form-row">
        <label for="node-input-timeout"><i class="fa fa-hourglass"></i> Timeout</label>
        <input type="text" id="node-input-timeout" placeholder="timeout">
    </div>
    <div class="form-row">
        <label for="node-input-name"><i class="fa fa-tag"></i> Name</label>
        <input type="text" id="node-input-name" placeholder="Name">
    </div>
    <div class="form-tips">
        <b>PromQL</b>: If left empty, <code>msg.payload</code> will be used as value.
    </div><br>
</script>

<script type="text/html" data-help-name="prometheus-query">
    <p>A set of Nodes to communicate with the Prometheus API</p>
</script>
